package indi.felix.easy.core.elastic;

import junit.framework.TestCase;
import org.elasticsearch.index.query.TermQueryBuilder;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class EasyEsTest extends TestCase {
    private static final String ip = "localhost:9200";

    public void testBulkAddDoc() {
        EasyEs easyEs = new EasyEs(ip);
        String index = "test_index";

        List<Map> object = new ArrayList<>();

        Map<String, Object> m1 = new HashMap<>();
        m1.put("name", "ceshi1");
        m1.put("age", 2);


        Map<String, Object> m2 = new HashMap<>();
        m2.put("name", "dsadsa");
        m2.put("age", 12);


        Map<String, Object> m3 = new HashMap<>();
        m3.put("name", "sdav");
        m3.put("age", 40);

        object.add(m1);
        object.add(m2);
        object.add(m3);

        easyEs.bulkAddDoc(index, object);

        TermQueryBuilder termQueryBuilder = new TermQueryBuilder("age", 12);

        String res = easyEs.rest().search().requestByQuery(index, termQueryBuilder);
        System.out.println(res);
    }
}