#canal


Canal与DTS提供的功能基本相似：
 - 1）基于Mysql的Slave协议实时dump binlog流，解析为事件发送给订阅方。
 - 2）单Canal instance，单DTS数据订阅通道均只支持订阅一个RDS，提供给一个消费者。
 - 3）可以使用canal-client客户端进行消息消费。
 - 4）也可以通过简单配置，也可以不需要自行使用canal-client消费，可以选择直接投递到kafka或者RocketMQ集群，用户只需要使用消息队列的consumer消费即可。
 - 5）成功消费消息后需要进行Ack，以确保一致性，服务端则会维护客户端目前的消费位点。

canal-server架构

说明：server代表一个canal-server运行实例，对应于一个jvminstance对应于一个数据队列，是真正的变更抓取的实体 （1个server可以对应多个instance)Instance模块EventParser ：数据源接入，模拟slave协议和master进行交互，协议解析EventSink ：Parser和Store链接器，进行数据过滤，加工，分发的工作EventStore ：数据存储MetaManager：增量订阅&消费信息管理器

##客户端使用
数据格式已经在前文给出，Canal和DTS客户端均采取：
拉取事件 -> 消费 -> 消费成功后ACK
这样的消费模式，并支持消费不成功时进行rollback，重新消费该数据。
### 5.1 优点

- 1）性能优异、功能全面
    -   canal 1.1.x 版本（release_note）,性能与功能层面有较大的突破,重要提升包括:
    -   整体性能测试&优化,提升了150%. #726
    -   原生支持prometheus监控 #765
    -   原生支持kafka消息投递 #695
    -   原生支持aliyun rds的binlog订阅 (解决自动主备切换/oss binlog离线解析) （无法拒绝它的理由！）
    -   原生支持docker镜像 #801
- 2）运维方便
    -   canal 1.1.4版本，迎来最重要的WebUI能力，引入canal-admin工程，支持面向WebUI的canal动态管理能力，支持配置、任务、日志等在线白屏运维能力
    -   Standalone的一体化解决方案，无外部服务依赖，运维更简单，在某种程度上也意味着更稳定。
    -   开箱即用，节约开发与定制成本。
    -   有良好的管理控制平台与监控系统（如果你已经有promethus监控，可以秒接canal监控）
- 3）多语言支持
        - canal 特别设计了 client-server 模式，交互协议使用 protobuf 3.0 , client 端可采用不同语言实现不同的消费逻辑
        - canal 作为 MySQL binlog 增量获取和解析工具，可将变更记录投递到 MQ 系统中，比如 Kafka/RocketMQ，可以借助于 MQ 的多语言能力

### 5.2 缺点

- 单instance/订阅通道只支持订阅单个数据库，并只能支持单客户端消费。每当我们需要新增一个消费端->MySQL的订阅：对于Canal而言，就要给MySQL接一个“Slave”，可能会对主库有一定影响。
- 消息的Schema很弱，所有消息的Schema均相同，客户端需要提前知道各个表消息的Schema与各字段的上下文才能正确消费。
