package indi.felix.easy.canal;

import lombok.Data;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;

/**
 * Canal服务配置
 *
 * @author felix
 * @since JDK 1.8
 */
@Configuration
@Data
public class CanalConfig
{
    @Value("${spring.cache.server.cluster:false}")
    private boolean cluster;

    @Value("${spring.cache.server.hostName:localhost}")
    private String hostName;

    @Value("${spring.cache.server.port:11111}")
    private int port;

    @Value("${spring.cache.server.destination:example}")
    private String destination;

    @Value("${spring.cache.server.userName:}")
    private String userName;

    @Value("${spring.cache.server.password:}")
    private String password;

    @Value("${spring.cache.server.zkServers:}")
    private String zkServers;

    @Value("${spring.cache.server.dbName:}")
    private String listenerDb;
}