package indi.felix.easy.core.elastic.client;

import indi.felix.easy.core.elastic.EasyEs;
import javafx.util.Pair;
import junit.framework.TestCase;
import org.elasticsearch.index.query.TermQueryBuilder;
import org.elasticsearch.search.builder.SearchSourceBuilder;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class EasyEsServiceTest extends TestCase {
    public void testBulk(){

        EasyEs easyEs = new EasyEs("localhost:9200");

        List<Map> mapList = new ArrayList<>();
        for (int i=0; i < 10000; i++){
            Map<String, Object> map = new HashMap<>();
            map.put("name", "user" + i);
            map.put("age", i);
            map.put("id", "000000" + i);
            map.put("routing", "000000" + i);
            mapList.add(map);
        }

        ArrayList<Pair<String, Object>> res =
                easyEs.search().bulkInsert("test11", mapList, 2000);

        System.out.println(res.size());
    }


    public void testSearchResponse() {
    }

    public void testSearch() {
    }

    public void testTestSearch() {
    }

    public void testTestSearchResponse() {
    }

    public void testTestSearch1() {
    }

    public void testScroll() throws IOException {
        EasyEs easyEs = new EasyEs("localhost:9200");
        TermQueryBuilder termQueryBuilder = new TermQueryBuilder("pa_sex", "女");
        SearchSourceBuilder searchSourceBuilder = new SearchSourceBuilder();
        searchSourceBuilder.query(termQueryBuilder);
        easyEs.search().scrollForResponse("csmsearch", searchSourceBuilder, searchHit -> {
            System.out.println("查询" + searchHit.getHits().getHits().length);
        });

        easyEs.search().scrollForResponse("csmsearch", searchSourceBuilder, searchHit -> {
            System.out.println("查询" + searchHit.getHits().getHits().length);
        });
    }

    public void testSearchAfter() throws IOException {
        EasyEs easyEs = new EasyEs("localhost:9200");
        TermQueryBuilder termQueryBuilder = new TermQueryBuilder("pa_sex", "女");

        SearchSourceBuilder searchSourceBuilder = new SearchSourceBuilder();
        searchSourceBuilder.query(termQueryBuilder);
        easyEs.search().searchForResponse("csmsearch", searchSourceBuilder, searchHit -> {
            System.out.println("查询" + searchHit.getHits().getHits().length);
        });

    }

    public void testSearchResponsePage() {
    }

    public void testSearchForResponse() {
    }

    public void testTestSearchForResponse() {
    }

    public void testTestSearchForResponse1() {
    }

    public void testSearchForHit() {
        EasyEs easyEs = new EasyEs("localhost:9200");

    }

    public void testTestSearchForHit() {
    }

    public void testQueryPage() {
    }
}