package indi.felix.easy.core.elastic.rest;

import indi.felix.easy.core.elastic.EasyEs;
import junit.framework.TestCase;
import org.elasticsearch.index.query.TermQueryBuilder;

public class SearchRestApiTest extends TestCase {
    private static final String ip = "localhost:9200";
    public void testRequestByIds() {
        EasyEs easyEs = new EasyEs(ip);
        String testIndexName = "edc_index";
        String[] ids = { "pa_18978559", "pa_44958156"};
        String res = easyEs.rest().search().requestByIds(testIndexName, ids);

        System.out.println(res);
    }


    public void testRequestByQuery() {
        EasyEs easyEs = new EasyEs(ip);
        String testIndexName = "edc_index";

        TermQueryBuilder queryBuilder = new TermQueryBuilder("pa_empi", "42301539");

        String res = easyEs.rest().search().requestByQuery(testIndexName, queryBuilder);

        System.out.println(res);
    }
}